            #GIT_CMT=6b5055cc66ae949b35297eb0bcad573a055a8d87
# GOLANG version
%global golang_version		1.10.8
%global golang_md5sum_amd64     54a77239467e894038600e056f3a6734
%global golang_md5sum_arm64     020825ff5e78689885c22d7abbff3931
%global system_name		containerd

Name:		containerd
Version:	1.2.0
Release:    1.0.5.el7
Summary:	Industry-standard container runtime
License:	ASL 2.0
Group:          System/Management
URL:		https://github.com/containerd/containerd
Vendor:		Oracle America
Source0: containerd-1.2.0.tar.bz2
Source1:        containerd.service

Requires(pre):	shadow-utils
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

# required packages on install
Requires: /bin/sh
Requires: container-selinux >= 2.9
Requires: libseccomp >= 2.3
Requires: iptables
Requires: libcgroup
Requires: systemd-units
Requires: tar
Requires: xz

BuildRequires: libseccomp-devel >= 2.3
BuildRequires: btrfs-progs-devel

%description
containerd is an industry-standard container runtime with an emphasis on simplicity, robustness and portability. It is available as a daemon for Linux and Windows, which can manage the complete container lifecycle of its host system: image transfer and storage, container execution and supervision, low-level storage and network attachments, etc.


%prep
%setup -q -n %{name}-%{version}

%build

# GOLANG use upstream
mkdir -p $(pwd)/.gobin
MACH=$(uname -m)
if [[ "x$MACH" = xx86_64 ]]; then
    ARCH=amd64
    ARCH_MD5SUM="%golang_md5sum_amd64"
elif [[ "x$MACH" = xaarch64 ]]; then
    ARCH=arm64
    ARCH_MD5SUM="%golang_md5sum_arm64"
else
    echo "Unsupported architecture"
    exit 1
fi
GO_ARCHIVE=go%{golang_version}.linux-${ARCH}.tar.gz
curl -#fSLO "https://golang.org/dl/${GO_ARCHIVE}"
GO_MD5SUM=$(md5sum "${GO_ARCHIVE}" | cut -f1 -d' ')
if [[ "$GO_MD5SUM" != "$ARCH_MD5SUM" ]]; then
    echo "golang download checksum error"
fi

tar xzC $(pwd)/.gobin < "${GO_ARCHIVE}"
export GOROOT=$(pwd)/.gobin/go
export GOBIN=$(pwd)/.gobin/go/bin
export PATH=$GOBIN:$PATH

mkdir -p src/github.com/containerd
ln -sr $(pwd) src/github.com/containerd/containerd
export GOPATH=$(pwd)
cd src/github.com/containerd/containerd

# update REVISION to upstream commit ID when updating the code
# update VERSION to `git describe --match 'v[0-9]*' --always`
make \
    VERSION=v1.2.0-rc.0-108-gc444666 \
    REVISION=c4446665cb9c30056f4998ed953e6d4ff22c7c39

%install
make install DESTDIR=%{buildroot}%{_prefix}
install -d $RPM_BUILD_ROOT/%{_unitdir}
install -p -m 644 %SOURCE1 $RPM_BUILD_ROOT/%{_unitdir}/containerd.service

%files
%license LICENSE
%{_bindir}/containerd
%{_bindir}/containerd-shim
%{_bindir}/containerd-shim-runc-v1
%{_bindir}/containerd-stress
%{_bindir}/ctr
%{_unitdir}/containerd.service

%preun
%systemd_preun containerd

%postun
%systemd_postun_with_restart containerd

%changelog
* Tue Feb 12 2019 Laszlo (Laca) Peter <laszlo.peter@oracle.com> - 1.2.0-1.0.5.el7
- update runc for CVE-2019-5736 (Laszlo (Laca) Peter)

* Fri Feb 08 2019 Laszlo (Laca) Peter <laszlo.peter@oracle.com> - 1.2.0-1.0.4.el7
- update to Go 1.10.8, fix version strings (Laszlo (Laca) Peter)

* Thu Oct 25 2018 Laszlo (Laca) Peter <laszlo.peter@oracle.com> - 1.2.0-1.0.3.el7
- add RPM spec file

* Wed Oct 03 2018 laszlo.peter@oracle.com - 1.2.0-1.0.1
- initial spec file

